
// source: book "Expert C Programming" and Usenet comp.lang.c newsgroup

#include <stdio.h>

//////////////////////////////////////////////////////////////////
// 16x16 bitmap definition
//////////////////////////////////////////////////////////////////

#define O )*2+1
#define _ )*2
#define I ((((((((((((((((0 // For building glyphs 16 bits wide

static unsigned short stopwatch[] =
{
    I   _ _ _ _ _ O O O O O _ _ _ O O _   ,
    I   _ _ _ O O O O O O O O O _ O O O   ,
    I   _ _ O O O _ _ _ _ _ O O O _ O O   ,
    I   _ O O _ _ _ _ _ _ _ _ _ O O _ _   ,
    I   _ O O _ _ _ _ _ _ _ _ _ O O _ _   ,
    I   O O _ _ _ _ _ _ _ _ _ _ _ O O _   ,
    I   O O _ _ _ _ _ _ _ _ _ _ _ O O _   ,
    I   O O _ O O O O O _ _ _ _ _ O O _   ,
    I   O O _ _ _ _ _ O _ _ _ _ _ O O _   ,
    I   O O _ _ _ _ _ O _ _ _ _ _ O O _   ,
    I   _ O O _ _ _ _ O _ _ _ _ O O _ _   ,
    I   _ O O _ _ _ _ O _ _ _ _ O O _ _   ,
    I   _ _ O O O _ _ _ _ _ O O O _ _ _   ,
    I   _ _ _ O O O O O O O O O _ _ _ _   ,
    I   _ _ _ _ _ O O O O O _ _ _ _ _ _   ,
    I   _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _   ,
};

#undef O
#undef _
#undef I
//////////////////////////////////////////////////////////////////

int main() {
    printf("16x16 bitmap binary size = %zu B\n",sizeof(stopwatch));
    printf("\n");
    for(int y=0; y<16; ++y) {
       for(int x=0; x<16; ++x) {
           printf(" %c", (stopwatch[y]&(1<<(15-x)))? 'O':'_');
       }
        printf("\n");
    }
    printf("\n");
}

