
// info: https://github.com/torvalds/linux/blob/master/tools/include/linux/overflow.h

#include <stdio.h>
#include <assert.h>

int main(void)
{
  int x1 = -1073741826;
  int y1 = -1073741826;
  int z1 = x1 + y1;
  int temp;

  printf("__builtin_add_overflow(x1, y1, &temp) test\n\n");
  printf("x1=%d\n", x1);
  printf("y1=%d\n", y1);
  int x = __builtin_add_overflow(x1, y1, &temp); //temp=x1+y1
  printf("result: %d ",x);
  if (x) {
    printf(" => overflow detected");
  }
  printf("\n");
  printf("temp=%d\n", temp);
  printf("(z1=x1+y1) == %d\n", z1);

}

