
// simple example of tail call optimization
// compile with -O2
// use gcc -O2 -S

#include <stdlib.h>

__attribute__((noinline))       // disable inlining
int add(int a, int b) {
   return a+b;
}

int add_abs(int a, int b) {
   return add(abs(a),abs(b));   // jump instead of call+ret
}

int main() {
    return add_abs(-1,-2);      // + compile-time optimization of abs()
}
