
// use C11: gcc -std=c11
// other examples: tgmath.h

#include <stdio.h>

// generic macro
#define PRINT(x) _Generic((x),                    \
                    double:  printf("%g\n", (x)), \
                    int:     printf("%d\n", (x)), \
                    default: printf("unknown")    \
                 )

int main() {
    int x=11;
    PRINT(x);
    double y=0.1;
    PRINT(y+x);
}
