
// Simple Undefined Behaviour (UB) example
//
// See: https://blog.regehr.org/archives/1520
// Try: gcc, tcc, clang, ...
//      gcc -ftrapv
//      gcc -fsanitize=undefined

#include <stdio.h>
#include <limits.h>

int main(int argc, char *argv[]) {
    int a;                      // any value
    if(argc>1) a=INT_MAX;       // a+1 overflows

    if(a+1<a)                   // UB if signed int overflows
        printf("a+1<a\n");      // GCC: optimized out
    else
        printf("NOT a+1<a\n");
    return a>=0;
}
